package com.ruoyi.platform.service;

import com.ruoyi.platform.domain.Component;
import com.ruoyi.platform.vo.ComponentVo;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;

import java.util.List;
import java.util.Map;

/**
 * (Component)表服务接口
 *
 * @author Xidaray
 * @since 2023-11-30 11:36:02
 */
public interface ComponentService {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    Component queryById(Integer id);

    /**
     * 分页查询
     *
     * @param component 筛选条件
     * @param pageRequest      分页对象
     * @return 查询结果
     */
    Page<Component> queryByPage(Component component, PageRequest pageRequest);

    /**
     * 新增数据
     *
     * @param component 实例对象
     * @return 实例对象
     */
    Component insert(ComponentVo component);

    /**
     * 修改数据
     *
     * @param component 实例对象
     * @return 实例对象
     */
    Component update(ComponentVo component);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */
    boolean deleteById(Integer id);

    String removeById(Integer id) throws Exception;

    List<Map>  queryAllGroupedByCategory() throws Exception;

}
